=== debian/changelog ===
flash3kyuu-deband-dmo (2.0.0.1-dmo2) unstable; urgency=medium

  * Should Depends on vapoursynth

 -- Christian Marillat <marillat@deb-multimedia.org>  Thu, 11 Apr 2019 10:11:02 +0200

flash3kyuu-deband-dmo (2.0.0.1-dmo1) unstable; urgency=medium

  * Initial release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Thu, 22 Jun 2017 17:27:07 +0200
