=== debian/control ===
Source: flash3kyuu-deband-dmo
Section: video
Priority: optional
Maintainer: Christian Marillat <marillat@deb-multimedia.org>
Bugs: mailto:marillat@deb-multimedia.org
Homepage: https://github.com/SAPikachu/flash3kyuu_deband
Standards-Version: 4.3.0
Build-Depends: debhelper-compat (= 12), python, vapoursynth-dev

Package: vapoursynth-flash3kyuu-deband
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, vapoursynth
Description: deband filter for vapoursynth
 It works by replacing banded pixels with average value of referenced
 pixels, and optionally add grain (random dithering) to them.
