=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_configure:
	./waf configure --prefix=/usr \
	--libdir=/usr/lib/$(DEB_HOST_MULTIARCH)/vapoursynth

override_dh_auto_build:
	./waf build

override_dh_auto_install:
	./waf install --destdir=debian/vapoursynth-flash3kyuu-deband

	$(RM) -rf debian/vapoursynth-flash3kyuu-deband/usr/include

override_dh_auto_clean:
	./waf distclean

override_dh_installchangelogs:
	dh_installchangelogs docs/source/change_log.rst
