=== debian/watch ===
version=4

https://github.com/SAPikachu/flash3kyuu_deband/releases \
(?:.*?/)?v?(\d[\d.]*)\.tar\.gz
